searchNodes=[{"doc":"Conventions for managing state of LiveViews and LiveComponents. See the README for another overview and some examples. Here are the core concepts – many of which are shared across both LiveViews and LiveComponents. Props Supported by LiveAssign.LiveComponent . Props are a one-way street: they are assigns that can only be passed in to a component, and are not modified internally beyond that. Props can be required by the component, or made optional with a default value. Reactive functions can be triggered by prop changes. See LiveAssign.LiveComponent.prop/2 for details. Slots Supported by LiveAssign.LiveComponent . LiveComponent slots are represented as &quot;slot props&quot;. They may be required or optional. See LiveAssign.LiveComponent.slot/2 for details. State Supported by LiveAssign.LiveView and LiveAssign.LiveComponent . State is used to track internal LiveView and LiveComponent logic, and can be modified throughout their lifecycles. State can be initialized with default values. Reactive functions can be triggered by state changes. See LiveAssign.LiveComponent.state/2 and LiveAssign.LiveView.state/2 for details. Reactive Functions Supported by LiveAssign.LiveView and LiveAssign.LiveComponent . Reactive functions are regular functions tagged with the @react attribute. They can be triggered by changes to props or state. See LiveAssign.React for details. Configuration LiveAssign performs some validations at runtime to provide helpful error messages to developers. You may wish to disable these checks - for example, to improve performance in a production environment. That is possible with: config :live_assign , runtime_checks? : false","ref":"LiveAssign.html","title":"LiveAssign","type":"module"},{"doc":"Extend LiveComponents. Usage Add use LiveAssign.LiveComponent to a Phoenix.LiveComponent . This adds: import LiveAssign.LiveComponent to make macros and functions locally available prop :id to define the required :id prop assign mount/1 and update/2 default implementations (can safely overriden) LiveAssign.LiveComponent Example defmodule MyAppWeb.UserProfileComponent do use Phoenix.LiveComponent use LiveAssign.LiveComponent prop :profile prop :show_avatar? , default : false state :age state :expand_details? , default : false slot :inner_block def handle_event ( &quot;toggle-details&quot; , _ , socket ) do { :noreply , put_state ( socket , socket , expand_details? : not socket . assigns . expand_details? ) } end def handle_event ( &quot;select&quot; , %{ &quot;profile_id&quot; =&gt; profile_id } } , socket ) do { :noreply , emit ( socket , :on_selected , profile_id ) } end @react to : :profile defp put_age ( socket ) do age = trunc ( Date . diff ( Date . utc_today ( ) , socket . assigns . profile . birthday ) / 365 ) put_state ( socket , age : age ) end end","ref":"LiveAssign.LiveComponent.html","title":"LiveAssign.LiveComponent","type":"module"},{"doc":"Defines a LiveEvent event prop. Event props are always optional, and default to nil . They are designed to work with the LiveEvent library. Following LiveEvent conventions, the value of this prop must be a destination to receive the event, either a pid or {module, id} . See LiveEvent.emit/3 for details on raising events. The emitted event name defaults to the name of the event prop. The event name can be overridden by the parent specifying {pid, :my_custom_event_name} or {module, id, :my_custom_event_name} . Example (LiveEvent required) # To define it on the LiveComponent: event :on_selected # To raise it from the LiveComponent: emit ( socket , :on_selected , &quot;some payload&quot; ) # To handle it somewhere else: handle_event ( :on_selected , { module , id } , &quot;some payload&quot; , socket )","ref":"LiveAssign.LiveComponent.html#event/1","title":"LiveAssign.LiveComponent.event/1","type":"macro"},{"doc":"Defines a prop. prop :id is automatically defined as a required prop for all components that use LiveAssign.LiveComponent , because every stateful LiveComponent requires an :id . Options :default - optional; if specified, this prop is considered optional, and will be assigned the default value during mount. If not specified, the prop is considered required. nil is a valid default value. The expression for the default value is wrapped in a function and its evaluation is deferred until runtime at the moment the component is mounted. Example # A required prop prop :visible? # An optional prop prop :thumbnail_url , default : nil","ref":"LiveAssign.LiveComponent.html#prop/2","title":"LiveAssign.LiveComponent.prop/2","type":"macro"},{"doc":"Updates state assigns. When called outside of a reactive function, any reactive functions that depend on the changed state will be immediately evaluated, so call this function as infrequently as possible. In other words, try to batch state changes and limit put_state/2 calls to once per lifecycle event. Within a reactive function, any additionally-triggered reactive functions will be deferred until after the current reactive function completely executes. Returns the socket with the new state and after any reactive callbacks have run. Example state :first_name put_state ( socket , first_name : &quot;Marvin&quot; )","ref":"LiveAssign.LiveComponent.html#put_state/2","title":"LiveAssign.LiveComponent.put_state/2","type":"function"},{"doc":"Defines a slot prop. Options :required? - defaults to true . When false , the prop given the empty slot value of [] Example # Default slot name slot :inner_block # Optional slot slot :navbar , required? : false","ref":"LiveAssign.LiveComponent.html#slot/2","title":"LiveAssign.LiveComponent.slot/2","type":"macro"},{"doc":"Defines a state assign. State is internal to the component and is modified via put_state/2 . Options :default - optional; if specified, the state will be assigned the default value during mount. The expression for the default value is wrapped in a function and its evaluation is deferred until runtime at the moment the component is mounted. If not specified, you should put_state/2 during component initialization to set an initial value. Example # State with no initial value state :changeset # State with an initial value, evaluated during mount state :now , default : DateTime . utc_now ( )","ref":"LiveAssign.LiveComponent.html#state/2","title":"LiveAssign.LiveComponent.state/2","type":"macro"},{"doc":"Extend LiveViews. Add use LiveAssign.LiveView to a Phoenix.LiveView . This adds: import LiveAssign.LiveView to make macros and functions locally available Hooks into mount and handle_info","ref":"LiveAssign.LiveView.html","title":"LiveAssign.LiveView","type":"module"},{"doc":"Updates state assigns. When called outside of a reactive function, any reactive functions that depend on the changed state will be immediately evaluated, so call this function as infrequently as possible. In other words, try to batch state changes and limit put_state/2 calls to once per function. Within a reactive function, any additionally-triggered reactive functions will be deferred until after the current reactive function completely executes. Returns the socket with the new state and after any reactive callbacks have run. Example state :first_name put_state ( socket , first_name : &quot;Marvin&quot; )","ref":"LiveAssign.LiveView.html#put_state/2","title":"LiveAssign.LiveView.put_state/2","type":"function"},{"doc":"Defines a state assign. State is internal to the view and is modified via put_state/2 . Options :default - optional; if specified, the state will be assigned the default value during mount. The expression for the default value is wrapped in a function and its evaluation is deferred until runtime at the moment the view is mounted. If not specified, you should put_state/2 during view initialization to set an initial value. Example # State with no initial value state :changeset # State with an initial value, evaluated during mount state :now , default : DateTime . utc_now ( )","ref":"LiveAssign.LiveView.html#state/2","title":"LiveAssign.LiveView.state/2","type":"macro"},{"doc":"Define reactive functions. A reactive function is tagged with the @react attribute and has an arity of 1, accepting the %LiveView.Socket{} as its argument, and returning the modified socket. @react to : [ :some_prop , :some_state ] defp put_changes ( socket ) do # ... end Reactive functions can subscribe to changes in state assigns or, in Live Compoents, prop assigns. Options for @react :to - required; an atom, or list of atoms, specifying the state and prop fields to subscribe to :repeats? - optional, defaults to false ; when true , disables infinite loop detection Infinite Loop Detection If a reactive function is executed multiple times during a single update cycle, this indicates a possible infinite loop of reactive callbacks, and a RuntimeError will be raised. This check can be bypassed with the repeats?: true option on the @react attribute. Example defmodule MyComponent do use Phoenix.LiveComponent use LiveAssign.LiveComponent prop :first_name prop :last_name state :big_display_name state :display_name state :full_name? , default : false # Triggered when there are any changes to these props or state @react to : [ :first_name , :last_name , :full_name? ] defp put_display_name ( socket ) do if socket . assigns . full_name? do put_state ( socket , display_name : &quot; \#{ socket . assigns . first_name , socket . assigns . last_name } &quot; ) else put_state ( socket , display_name : socket . assigns . first_name ) end end # Triggered after put_display_name/1 finishes @react to : :display_name defp put_big_display_name ( socket ) do put_state ( socket , big_display_name : String . upcase ( socket . assigns . display_name ) ) end end","ref":"LiveAssign.React.html","title":"LiveAssign.React","type":"module"},{"doc":"LiveAssign improves state management by sprinkling functionality on top of Phoenix LiveView. It doesn't replace the LiveView way of doing things, but instead augments it with conventions. LiveAssign can be added to any view or component without affecting existing functionality, and its features can be opted-in as they are needed. Combine it with LiveEvent for an altogether improved component-building experience. LiveViews and LiveComponents both gain: State assigns which are defined in the module Reactive functions that are automatically invoked upon state changes Runtime checks with developer-friendly error messages LiveComponents also gain additional functionality: Props which are assigns that are strictly passed in to the component Slot props to represent component slots Event props that integrate with LiveEvent Here are a couple examples showing off these features. For complete details, please reference the docs .","ref":"readme.html","title":"LiveAssign","type":"extras"},{"doc":"defmodule MyAppWeb.UserProfileComponent do use Phoenix.LiveComponent use LiveAssign.LiveComponent prop :profile prop :show_avatar? , default : false state :age state :expand_details? , default : false slot :inner_block def handle_event ( &quot;toggle-details&quot; , _ , socket ) do { :noreply , put_state ( socket , expand_details? : not socket . assigns . expand_details? ) } end @react to : :profile defp put_age ( socket ) do age = trunc ( Date . diff ( Date . utc_today ( ) , socket . assigns . profile . birthday ) / 365 ) put_state ( socket , age : age ) end # ... end The :profile assign is a required prop . If it is not passed in, a helpful runtime error will occur. The :id assign is also a required prop, but it is implicitly defined by use LiveAssign.LiveComponent , because every LiveComponent requires an :id . The :show_avatar? assign is an optional prop that defaults to false when unspecified. The :expand_details? and :age assigns are state . They can be modified via put_state/2 . The :inner_block assign is a slot prop . It is required but can be made optional with the required?: false option. The put_age/1 function is a reactive callback . It is automatically evaluated whenever the value of the :profiles state changes. The function can react to prop changes and state changes.","ref":"readme.html#livecomponent-example","title":"LiveAssign - LiveComponent Example","type":"extras"},{"doc":"defmodule MyAppWeb.ProfileIndexLive do use Phoenix.LiveView use LiveAssign.LiveView state :profiles , default : load_profiles ( ) state :profile_count @react to : :profiles defp put_profile_count ( socket ) do put_state ( socket , profile_count : length ( socket . assigns . profiles ) ) end defp load_profiles , do : # ... # ... end The :profiles and :profile_count assigns are state . They can be modified throughout the LiveView lifecycle, and reactive functions can respond to their changes. The put_profile_count/1 callback is a reactive function that is automatically invoked as soon as any changes occur to the :profiles state.","ref":"readme.html#liveview-example","title":"LiveAssign - LiveView Example","type":"extras"},{"doc":"The package can be installed by adding live_assign to your list of dependencies in mix.exs : def deps do [ { :live_assign , &quot;~&gt; 0.3.0&quot; } ] end","ref":"readme.html#installation","title":"LiveAssign - Installation","type":"extras"}]